IF EXISTS(SELECT * 
            FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'GERA_ICMS_INTERESTADUAL'  
             AND TYPE   = 'P'
             AND U.UID  = O.UID
             AND U.NAME = USER)
   DROP PROCEDURE GERA_ICMS_INTERESTADUAL
GO

CREATE PROCEDURE GERA_ICMS_INTERESTADUAL
   @P_CDFILIAL   VARCHAR(04),
   @P_NRLANCTONF VARCHAR(10),
   @P_NRSEQITPROD VARCHAR(04),
   @P_DTINIVALID DATETIME
AS
   /* INICIO DA DECLARAO DAS VARIVEIS DO CURSOS C_ITEMPRODUTO */
   DECLARE @C_ITEMPRODUTO_NRSEQITPROD VARCHAR(04);
   DECLARE @C_ITEMPRODUTO_CDARVPROD VARCHAR(20);
   DECLARE @C_ITEMPRODUTO_VRTOTAITEM FLOAT;
   DECLARE @C_ITEMPRODUTO_VRDESCITEM FLOAT;
   DECLARE @C_ITEMPRODUTO_IDORIGEMPROD VARCHAR(01);
   DECLARE @C_ITEMPRODUTO_CDFISCOPERSN VARCHAR(04);
   /* FIM DA DECLARAO DAS VARIVEIS DO CURSOS C_ITEMPRODUTO */
   /* INICIO DA DECLARAO DAS VARIVEIS DO CURSOS C_VRIMPOPARTDEST */
   DECLARE @C_VRIMPOPARTDEST_VRALIQINTEDEST FLOAT;
   DECLARE @C_VRIMPOPARTDEST_VRALIQFCP FLOAT;
   DECLARE @C_VRIMPOPARTDEST_VRIMPOPARTDEST FLOAT
   DECLARE @C_VRIMPOPARTDEST_VRIMPOFCP FLOAT
   /* FIM DA DECLARAO DAS VARIVEIS DO CURSOS C_ITEMPRODUTO */

   DECLARE @V_ALIQTEMP VARCHAR(18);
   DECLARE @V_EXISTENOTA VARCHAR(14);
   DECLARE @V_IDORIGDESTNF VARCHAR(01);
   DECLARE @V_CDFILIEMIT VARCHAR(04);
   DECLARE @V_CDCLIENTE VARCHAR(21);
   DECLARE @V_CDFORNECED VARCHAR(21);
   DECLARE @V_IDENDEMISFIL VARCHAR(01);
   DECLARE @V_IDENDEMISCLI VARCHAR(01);
   DECLARE @V_IDENDEMISFOR VARCHAR(01);
   DECLARE @V_CDPAISEMIT VARCHAR(04);
   DECLARE @V_SGESTADOEMIT VARCHAR(02);
   DECLARE @V_CDMUNICIPIOEMIT VARCHAR(04);
   DECLARE @V_CDPAISDEST VARCHAR(04);
   DECLARE @V_SGESTADODEST VARCHAR(02);
   DECLARE @V_CDMUNICIPIODEST VARCHAR(04);
   DECLARE @V_IDOPERINTEREST VARCHAR(01);
   DECLARE @V_IDCONSFINAL VARCHAR(01);
   DECLARE @V_NRINSESTDESNF VARCHAR(20);
   DECLARE @V_IDCONTRIBICMS VARCHAR(01);
   DECLARE @V_IDCONTRIBICMSAUX VARCHAR(01);
   DECLARE @V_EXISTEISSQN FLOAT;
   DECLARE @V_EXISTEIMPOSTO VARCHAR(18);
   DECLARE @V_CDIMPOSTO VARCHAR(02);
   DECLARE @V_CDEMPRESA VARCHAR(02);
   DECLARE @V_CDINSCESTA VARCHAR(16);
   DECLARE @V_IDENTRSAIDOP VARCHAR(01);
   DECLARE @V_CDTIPOOPER VARCHAR(02);
   DECLARE @V_DTEMISSAO DATE;
   DECLARE @V_DTINIVALID DATE;
   DECLARE @V_IDUTMUNIORIG VARCHAR(01);
   DECLARE @V_CDDESTNF VARCHAR(21);
   DECLARE @V_CDGRUPOFISC  VARCHAR(03);
   DECLARE @V_ALIQICMSDEST FLOAT;
   DECLARE @V_VRPERREDDEST FLOAT;
   DECLARE @V_ALIQFECPDEST FLOAT;
   DECLARE @V_IMPOQFECPDEST FLOAT;
   DECLARE @V_VRBASECALCDEST FLOAT;
   DECLARE @V_VRBASECALCREME FLOAT;
   DECLARE @V_VRALIQITEM FLOAT;
   DECLARE @V_VRBASECALCIT FLOAT;
   DECLARE @V_VRPERCPARTILHA FLOAT;
   DECLARE @V_VRIMPOSTODEST FLOAT;
   DECLARE @V_DIFPARTILHAICMS FLOAT;
   DECLARE @V_VRIMPOSTOIT FLOAT;
   DECLARE @V_VRIMPOSTOORIG FLOAT;
   DECLARE @V_VRIMPOPARTDEST FLOAT;
   DECLARE @V_VRIMPOPARTREME FLOAT;
   DECLARE @V_VRIMPOPARTDESTINO VARCHAR(16);
   DECLARE @V_VRALIQPARTDESTINO VARCHAR(06);
   DECLARE @V_VRIMPOFCPDESTINO VARCHAR(16);
   DECLARE @V_VRALIQFCPDESTINO VARCHAR(06);
   DECLARE @V_CDSITUTRIBITNFE VARCHAR(02);
   DECLARE @V_CDSITUCRT VARCHAR(01);
   DECLARE @V_VRLIQITEM FLOAT;
   DECLARE @V_CDIMPOSTOFECP VARCHAR(02);
   DECLARE @V_CDFISCALIT VARCHAR(01);
   DECLARE @V_NRDADOADIC VARCHAR(03);
   DECLARE @V_MSGDADOSADIC VARCHAR(255);
   DECLARE @V_IDPRESENCIAL VARCHAR(01);
   DECLARE @V_IDCALCDIFALDENT VARCHAR(01);
BEGIN
   SET @V_ALIQTEMP = @P_CDFILIAL + @P_NRLANCTONF;
   DELETE
     FROM ALIQTEMP
    WHERE NRALIQTEMP = @V_ALIQTEMP;
   UPDATE ITEMPROIMPOS
      SET VRBASECALCDEST = NULL,
          VRALIQINTEDEST = NULL,
          VRALIQINTEREST = NULL,
          VRPERCPARTILHA = NULL,
          VRIMPOPARTDEST = NULL,
          VRIMPOPARTREME = NULL,
          VRALIQFCP = NULL,
          VRIMPOFCP = NULL,
          VRBASECALCREME = NULL
    WHERE CDFILIAL = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF
      AND NRSEQITPROD = @P_NRSEQITPROD;
   DELETE
     FROM DADOSADIC
    WHERE CDFILIAL = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF
      AND DSDADOADIC LIKE 'Valor do ICMS interestadual para a UF de destino R$%';
   SELECT @V_EXISTENOTA = N.CDFILIAL + N.NRLANCTONF,
          @V_IDORIGDESTNF = N.IDORIGDESTNF,
          @V_CDFILIEMIT = CASE N.IDENTRSAIDOP WHEN 'S' THEN N.CDFILIEMIT ELSE N.CDFILIRECE END,
          @V_CDCLIENTE = N.CDCLIENTE,
          @V_CDFORNECED = N.CDFORNECED,
          @V_CDEMPRESA = N.CDEMPRESA,
          @V_CDINSCESTA = N.CDINSCESTA,
          @V_IDENTRSAIDOP = N.IDENTRSAIDOP,
          @V_CDTIPOOPER = N.CDTIPOOPER,
          @V_DTEMISSAO = N.DTEMISSAO,
          @V_IDPRESENCIAL = ISNULL(N.IDPRESENCIAL, '9'),
          @V_IDCALCDIFALDENT = ISNULL(T.IDCALCDIFALDENT, 'N')
     FROM NOTAFISCAL N, TIPOOPERAC T
    WHERE N.IDENTRSAIDOP = T.IDENTRSAIDOP
      AND N.CDTIPOOPER = T.CDTIPOOPER
      AND N.CDFILIAL = @P_CDFILIAL
      AND N.NRLANCTONF = @P_NRLANCTONF;
   SELECT @V_CDSITUCRT = ISNULL(CDSITUCRT, '3')
     FROM PARAMEMPRESA
    WHERE CDEMPRESA = @V_CDEMPRESA;
   IF @P_DTINIVALID IS NULL BEGIN
      SET @V_DTINIVALID = CAST(GETDATE() AS DATE);
   END ELSE BEGIN
      SET @V_DTINIVALID = CAST(@P_DTINIVALID AS DATE);
   END;
   IF @V_DTEMISSAO IS NULL BEGIN
      SET @V_DTEMISSAO = CAST(GETDATE() AS DATE);
   END;
   -- VERIFICANDO SE EXISTE A NOTAFISCAL E SE O DESTINO DA NOTA  UM CLIENTE OU FORNECEDOR
   IF (@V_EXISTENOTA IS NOT NULL) AND (@V_IDORIGDESTNF IN ('C', 'F')) BEGIN
      SELECT @V_IDENDEMISFIL = ISNULL(IDENDEMISFIL, 'I')
        FROM FILIAL
       WHERE CDFILIAL = @V_CDFILIEMIT;
      IF @V_IDENDEMISFIL = 'I' BEGIN
         SELECT @V_CDPAISEMIT = CDPAIS,
                @V_SGESTADOEMIT = SGESTADO,
                @V_CDMUNICIPIOEMIT = CDMUNICIPIO
           FROM INSCRESTAD
          WHERE CDEMPRESA = @V_CDEMPRESA
            AND CDINSCESTA = @V_CDINSCESTA;
      END ELSE BEGIN
         SELECT @V_CDPAISEMIT = CDPAIS,
                @V_SGESTADOEMIT = SGESTADO,
                @V_CDMUNICIPIOEMIT = CDMUNICIPIO
           FROM ENDEFILI
          WHERE CDFILIAL = @V_CDFILIEMIT
            AND IDTPENDEFILI = @V_IDENDEMISFIL;
      END;
      IF @V_IDORIGDESTNF = 'C' BEGIN --CLIENTE
         SELECT @V_IDENDEMISCLI = ISNULL(IDENDEMISCLI, 'P'),
                @V_IDCONSFINAL = ISNULL(IDCONSFINAL, 'N'),
                @V_NRINSESTDESNF = NRINSESTCLIE,
                @V_IDCONTRIBICMS = ISNULL(IDCONTRIBICMS, 'N')
           FROM CLIENTE
          WHERE CDCLIENTE = @V_CDCLIENTE;
         SELECT @V_CDPAISDEST = CDPAIS, 
                @V_SGESTADODEST = SGESTADO,
                @V_CDMUNICIPIODEST = CDMUNICIPIO
           FROM ENDECLIE
          WHERE CDCLIENTE = @V_CDCLIENTE
            AND IDTPENDECLIE = @V_IDENDEMISCLI;
         SET @V_CDDESTNF = @V_CDCLIENTE;
      END ELSE BEGIN 
         IF @V_IDORIGDESTNF = 'F' BEGIN --FORNECEDOR
            SELECT @V_IDENDEMISFOR = ISNULL(IDENDEMISFOR, 'P'),
                   @V_IDCONSFINAL = ISNULL(IDCONSFINAL, 'N'),
                   @V_NRINSESTDESNF = NRINSESTFORN,
                   @V_IDCONTRIBICMS = ISNULL(IDCONTRIBICMS, 'N')
              FROM FORNECEDOR
             WHERE CDFORNECED = @V_CDFORNECED;
            SELECT @V_CDPAISDEST = CDPAIS, 
                   @V_SGESTADODEST = SGESTADO,
                   @V_CDMUNICIPIODEST = CDMUNICIPIO
              FROM ENDEFORN
             WHERE CDFORNECED = @V_CDFORNECED
               AND IDTPENDEFORN = @V_IDENDEMISFOR;
         END;
         SET @V_CDDESTNF = @V_CDFORNECED;
      END;
      IF (@V_NRINSESTDESNF IS NULL) OR (@V_NRINSESTDESNF = '') BEGIN
         SET @V_IDCONTRIBICMSAUX = 'N';
      END ELSE BEGIN
         SET @V_IDCONTRIBICMSAUX = @V_IDCONTRIBICMS;
      END;
      SET @V_IDOPERINTEREST = 'N';
      --VERIFICANDO SE O ENDEREO DO EMITENTE DA NOTA FISCAL NO  NULO
      IF (@V_CDPAISEMIT IS NOT NULL) AND (@V_SGESTADOEMIT IS NOT NULL) BEGIN
         --VERIFICANDO SE O ENDEREO DO DESTINATRIO DA NOTA FISCAL NO  NULO
         IF (@V_CDPAISDEST IS NOT NULL) AND (@V_SGESTADODEST IS NOT NULL) BEGIN
            IF (@V_CDPAISEMIT = @V_CDPAISDEST) AND (@V_SGESTADOEMIT <> @V_SGESTADODEST) BEGIN
               SET @V_IDOPERINTEREST = 'S';
            END;
          END;
      END;
      --REALIZANDO AS SEGUINTES VERIFICAES:
      -- => VERIFICANDO SE A OPERAO  INTERESTADUAL
      -- => VERIFICANDO SE O DESTINO DA NOTA  UM CONSUMIDOR FINAL 
      -- => VERIFICANDO SE O DESTINO DA NOTA NO  CONTRIBUINTE DO ICMS, OU SEJA, NO POSSUI INSCRIO ESTADUAL CADASTRADA OU O PARMETRO IDCONTRIBICMS EST COMO 'N'
      -- => VERIFICANDO SE A OPERAO NO  PRESENCIAL
      IF (@V_IDOPERINTEREST = 'S') AND (@V_IDCONSFINAL = 'S') AND (@V_IDCONTRIBICMSAUX = 'N') AND (@V_IDPRESENCIAL <> '1') BEGIN
         DECLARE C_ITEMPRODUTO CURSOR FOR SELECT IT.NRSEQITPROD, 
                                                 P.CDARVPROD,
                                                 IT.VRTOTAITEM,
                                                 IT.VRDESCITEM,
                                                 IT.IDORIGEMPROD,
                                                 IT.CDFISCOPERSN
                                            FROM ITEMPRODUTO IT, PRODUTO P
                                           WHERE IT.CDPRODUTO = P.CDPRODUTO
                                             AND IT.CDFILIAL = @P_CDFILIAL
                                             AND IT.NRLANCTONF = @P_NRLANCTONF
                                             AND IT.NRSEQITPROD = @P_NRSEQITPROD
         OPEN C_ITEMPRODUTO;
         FETCH NEXT FROM C_ITEMPRODUTO INTO @C_ITEMPRODUTO_NRSEQITPROD,
                                            @C_ITEMPRODUTO_CDARVPROD,
                                            @C_ITEMPRODUTO_VRTOTAITEM,
                                            @C_ITEMPRODUTO_VRDESCITEM,
                                            @C_ITEMPRODUTO_IDORIGEMPROD,
                                            @C_ITEMPRODUTO_CDFISCOPERSN;
         WHILE (@@FETCH_STATUS = 0) BEGIN
            DELETE
              FROM ALIQTEMP
             WHERE NRALIQTEMP = @V_ALIQTEMP;
            SELECT @V_EXISTEISSQN= ISNULL(COUNT(*), 0)
              FROM ITEMPROIMPOS IT, IMPOSTO I
             WHERE IT.CDIMPOSTO = I.CDIMPOSTO
               AND IT.CDFILIAL = @P_CDFILIAL
               AND IT.NRLANCTONF = @P_NRLANCTONF
               AND IT.NRSEQITPROD = @C_ITEMPRODUTO_NRSEQITPROD
               AND I.CDIMPOSTONFE = '31';
            --VERIFICANDO SE O ITEM NO TEM INCIDENCIA DO IMPOSTO ISSQN
            IF @V_EXISTEISSQN = 0 BEGIN
               SELECT @V_EXISTEIMPOSTO = IT.CDFILIAL + IT.NRLANCTONF + IT.NRSEQITPROD,
                      @V_CDIMPOSTO = I.CDIMPOSTO,
                      @V_IDUTMUNIORIG = I.IDUTMUNIORIG,
                      @V_VRALIQITEM = IT.VRALIQITEM,
                      @V_VRBASECALCIT = IT.VRBASECALCIT,
                      @V_VRIMPOSTOIT = IT.VRIMPOSTOIT,
                      @V_CDSITUTRIBITNFE = IT.CDSITUTRIBITNFE,
                      @V_CDFISCALIT = IT.CDFISCALIT
                 FROM ITEMPROIMPOS IT, IMPOSTO I
                WHERE IT.CDIMPOSTO = CASE @V_CDSITUCRT WHEN '1' THEN I.CDIMPOSREGNORMA ELSE I.CDIMPOSTO END
                  AND IT.CDFILIAL = @P_CDFILIAL
                  AND IT.NRLANCTONF = @P_NRLANCTONF
                  AND IT.NRSEQITPROD = @C_ITEMPRODUTO_NRSEQITPROD
                  AND IT.NRITPROIMPOS = '1'
                  AND I.CDIMPOSTONFE = '00';
               --VERIFICANDO SE EXISTE A INCIDNCIA DE ICMS PARA O PRODUTO
               IF (@V_EXISTEIMPOSTO IS NOT NULL) BEGIN
                  --OS VALORES DO PERCENTUAL PROVISRIO DE PARTILHA ENTRE OS ESTADOS SO DEFINIDOS DE ACORDO COM A NOTA TCNICA 2015/003
                  SELECT @V_VRPERCPARTILHA = CASE YEAR(@V_DTEMISSAO)
                                             WHEN '2016' 
                                                THEN 40 
                                             ELSE 
                                                CASE YEAR(@V_DTEMISSAO)
                                                WHEN '2017'
                                                   THEN 60
                                                ELSE
                                                   CASE YEAR(@V_DTEMISSAO)
                                                   WHEN '2018'
                                                      THEN 80
                                                   ELSE
                                                      100
                                                   END
                                                END
                                             END;
                  EXEC CONSULTA_GRUPOFISCAL @V_IDORIGDESTNF,
                                            @V_CDDESTNF,
                                            @V_CDFILIEMIT,
                                            @V_IDENTRSAIDOP,
                                            @V_CDTIPOOPER,
                                            @V_CDGRUPOFISC;
                  SET @V_VRLIQITEM = @C_ITEMPRODUTO_VRTOTAITEM - @C_ITEMPRODUTO_VRDESCITEM;
                  IF @V_IDUTMUNIORIG = 'D' BEGIN
                     /* CONSIDERA O MUNICIPIO DE DESTINO */
                     EXEC CONSULTA_ALIQUOTA @V_CDIMPOSTO,
                                            @V_IDENTRSAIDOP,
                                            @V_CDEMPRESA,
                                            @C_ITEMPRODUTO_CDARVPROD,
                                            @V_CDINSCESTA,
                                            @V_CDPAISDEST,
                                            @V_SGESTADODEST,
                                            @V_CDPAISDEST,
                                            @V_SGESTADODEST,
                                            @V_CDMUNICIPIODEST,
                                            @V_VRLIQITEM,
                                            @V_DTINIVALID, 
                                            @P_CDFILIAL, 
                                            @P_NRLANCTONF, 
                                            @V_CDGRUPOFISC, 
                                            @V_CDTIPOOPER,
                                            NULL, 
                                            NULL, 
                                            NULL, 
                                            NULL, 
                                            NULL, 
                                            NULL, 
                                            @C_ITEMPRODUTO_IDORIGEMPROD;
                  END ELSE BEGIN
                     /* CONSIDERA O MUNICIPIO DE ORIGEM */
                     EXEC CONSULTA_ALIQUOTA @V_CDIMPOSTO, 
                                            @V_IDENTRSAIDOP, 
                                            @V_CDEMPRESA,
                                            @C_ITEMPRODUTO_CDARVPROD,
                                            @V_CDINSCESTA,
                                            @V_CDPAISDEST,
                                            @V_SGESTADODEST,
                                            @V_CDPAISDEST,
                                            @V_SGESTADODEST,
                                            @V_CDMUNICIPIOEMIT,
                                            @V_VRLIQITEM,
                                            @V_DTINIVALID,
                                            @P_CDFILIAL,
                                            @P_NRLANCTONF, 
                                            @V_CDGRUPOFISC, 
                                            @V_CDTIPOOPER,
                                            NULL, 
                                            NULL, 
                                            NULL, 
                                            NULL, 
                                            NULL, 
                                            NULL, 
                                            @C_ITEMPRODUTO_IDORIGEMPROD;
                  END;
                  SELECT @V_ALIQICMSDEST = MAX(VRALIQUTMP),
                         @V_VRPERREDDEST = ISNULL(MAX(VRPREDBCTMP), 0)
                    FROM ALIQTEMP
                   WHERE NRALIQTEMP = @V_ALIQTEMP;
                  IF @V_ALIQICMSDEST IS NULL BEGIN
                     SELECT @V_ALIQICMSDEST = ISNULL(TEKNISA.CONSULTA_QUADRO_ALIQUOTAS(@V_SGESTADODEST, @V_SGESTADODEST), 0);
                  END;
                  IF @V_VRALIQITEM <= @V_ALIQICMSDEST BEGIN
                     /* TER ATENO TAMBM NA REJEIO 694 (REJEIO: NO INFORMADO O GRUPO DE ICMS PARA A UF DE DESTINO) */
                     IF ((@V_CDSITUCRT <> '1') AND (@V_CDSITUTRIBITNFE IN ('00', '20', '40', '41', '60'))) OR /* FOI COLOCADO PARA EVITAR A REJEIO 508 (REJEIO: CST INCOMPATVEL NA OPERAO COM NO CONTRIBUINTE) */
                        ((@V_CDSITUCRT = '1') AND (SUBSTRING(@C_ITEMPRODUTO_CDFISCOPERSN, 2, 3) IN ('102', '103', '300', '400', '500'))) /* FOI COLOCADO PARA EVITAR A REJEIO 600 (REJEIO: CSOSN INCOMPATVEL NA OPERAO COM NO CONTRIBUINTE) */
                     BEGIN
                        /* CALCULANDO O VALOR DO FUNDO ESTADUAL DE COMBATE A POBREZA */
                        SELECT @V_CDIMPOSTOFECP = CDIMPOSTO
                          FROM IMPOSTO
                         WHERE CDIMPOSTONFE = '01';
                        IF @V_CDIMPOSTOFECP IS NOT NULL BEGIN
                           DELETE
                             FROM ALIQTEMP
                            WHERE NRALIQTEMP = @V_ALIQTEMP;
                           --VERIFICANDO SE EXISTE A INCIDNCIA DE FECP PARA O PRODUTO
                           IF @V_IDUTMUNIORIG = 'D' BEGIN
                              /* CONSIDERA O MUNICIPIO DE DESTINO */
                              EXEC CONSULTA_ALIQUOTA @V_CDIMPOSTOFECP,
                                                     @V_IDENTRSAIDOP,
                                                     @V_CDEMPRESA,
                                                     @C_ITEMPRODUTO_CDARVPROD,
                                                     @V_CDINSCESTA,
                                                     @V_CDPAISDEST,
                                                     @V_SGESTADODEST,
                                                     @V_CDPAISDEST,
                                                     @V_SGESTADODEST,
                                                     @V_CDMUNICIPIODEST,
                                                     @V_VRLIQITEM,
                                                     @V_DTINIVALID, 
                                                     @P_CDFILIAL, 
                                                     @P_NRLANCTONF, 
                                                     @V_CDGRUPOFISC, 
                                                     @V_CDTIPOOPER,
                                                     NULL, 
                                                     NULL, 
                                                     NULL, 
                                                     NULL, 
                                                     NULL, 
                                                     NULL, 
                                                     @C_ITEMPRODUTO_IDORIGEMPROD;
                           END ELSE BEGIN
                              /* CONSIDERA O MUNICIPIO DE ORIGEM */
                              EXEC CONSULTA_ALIQUOTA @V_CDIMPOSTOFECP, 
                                                     @V_IDENTRSAIDOP, 
                                                     @V_CDEMPRESA,
                                                     @C_ITEMPRODUTO_CDARVPROD,
                                                     @V_CDINSCESTA,
                                                     @V_CDPAISDEST,
                                                     @V_SGESTADODEST,
                                                     @V_CDPAISDEST,
                                                     @V_SGESTADODEST,
                                                     @V_CDMUNICIPIOEMIT,
                                                     @V_VRLIQITEM,
                                                     @V_DTINIVALID,
                                                     @P_CDFILIAL,
                                                     @P_NRLANCTONF, 
                                                     @V_CDGRUPOFISC, 
                                                     @V_CDTIPOOPER,
                                                     NULL, 
                                                     NULL, 
                                                     NULL, 
                                                     NULL, 
                                                     NULL, 
                                                     NULL, 
                                                     @C_ITEMPRODUTO_IDORIGEMPROD;
                           END;
                           SELECT @V_ALIQFECPDEST = ISNULL(MAX(VRALIQUTMP), 0)
                             FROM ALIQTEMP
                            WHERE NRALIQTEMP = @V_ALIQTEMP;
                        END ELSE BEGIN
                           SET @V_ALIQFECPDEST = 0;
                        END;                        
                        IF @V_VRALIQITEM = @V_ALIQICMSDEST BEGIN
                           SET @V_VRBASECALCREME = ROUND(@V_VRBASECALCIT, 2);
                           SET @V_VRIMPOSTOORIG = @V_VRIMPOSTOIT;
                           SET @V_VRBASECALCDEST = ROUND(@V_VRBASECALCIT, 2);
                           SET @V_VRIMPOSTODEST = @V_VRIMPOSTOIT;
                           SET @V_DIFPARTILHAICMS = ROUND(@V_VRIMPOSTODEST - @V_VRIMPOSTOORIG, 2);
                           SET @V_IMPOQFECPDEST = ROUND(@V_VRBASECALCDEST * (@V_ALIQFECPDEST / 100), 2);
                           SET @V_VRIMPOPARTDEST = ROUND(@V_DIFPARTILHAICMS * (@V_VRPERCPARTILHA / 100), 2);
                           SET @V_VRIMPOPARTREME =  ROUND((@V_DIFPARTILHAICMS - @V_VRIMPOPARTDEST), 2);
                        END ELSE BEGIN
                           IF (@V_CDPAISDEST = '0055') AND (UPPER(@V_SGESTADODEST) = 'MG') AND (@V_IDCALCDIFALDENT = 'S') BEGIN
                              -- EM MG O CLCULO  REALIZADO DE UMA FORMA DIFERENTE DE ACORDO COM A 
                              -- ORIENTAO TRIBUTRIA DOLT/SUTRI N 002/2016
                              IF @V_VRPERREDDEST > 0 BEGIN
                                 SET @V_VRBASECALCREME = ROUND(@V_VRBASECALCIT / (1 - ((@V_ALIQICMSDEST + @V_ALIQFECPDEST) / 100)), 2);
                                 SET @V_VRIMPOSTOORIG = @V_VRBASECALCREME * (@V_VRALIQITEM / 100);
                                 SET @V_VRBASECALCDEST = ROUND(@V_VRBASECALCREME - (@V_VRBASECALCREME * (@V_VRPERREDDEST / 100)), 2);
                                 SET @V_VRIMPOSTODEST = @V_VRBASECALCDEST * ((@V_ALIQICMSDEST + @V_ALIQFECPDEST) / 100);
                                 SET @V_DIFPARTILHAICMS = ROUND(@V_VRIMPOSTODEST - @V_VRIMPOSTOORIG, 2);
                                 SET @V_IMPOQFECPDEST = ROUND(@V_VRBASECALCDEST * (@V_ALIQFECPDEST / 100), 2);
                                 SET @V_VRIMPOPARTDEST = ROUND((@V_DIFPARTILHAICMS - @V_IMPOQFECPDEST) * (@V_VRPERCPARTILHA / 100), 2);
                                 SET @V_VRIMPOPARTREME =  ROUND((@V_DIFPARTILHAICMS - @V_IMPOQFECPDEST - @V_VRIMPOPARTDEST), 2);
                              END ELSE BEGIN
                                 SET @V_VRBASECALCREME = ROUND(@V_VRBASECALCIT / (1 - ((@V_ALIQICMSDEST + @V_ALIQFECPDEST) / 100)), 2);
                                 SET @V_VRIMPOSTOORIG = @V_VRBASECALCREME * (@V_VRALIQITEM / 100);
                                 SET @V_VRBASECALCDEST = ROUND(@V_VRBASECALCREME, 2);
                                 SET @V_VRIMPOSTODEST = @V_VRBASECALCDEST * ((@V_ALIQICMSDEST + @V_ALIQFECPDEST) /100);
                                 SET @V_DIFPARTILHAICMS = ROUND(@V_VRIMPOSTODEST - @V_VRIMPOSTOORIG, 2);
                                 SET @V_IMPOQFECPDEST = ROUND(@V_VRBASECALCDEST * (@V_ALIQFECPDEST / 100), 2);
                                 SET @V_VRIMPOPARTDEST = ROUND((@V_DIFPARTILHAICMS - @V_IMPOQFECPDEST) * (@V_VRPERCPARTILHA / 100), 2);
                                 SET @V_VRIMPOPARTREME =  ROUND((@V_DIFPARTILHAICMS - @V_IMPOQFECPDEST - @V_VRIMPOPARTDEST), 2);
                              END;
                           END ELSE BEGIN
                              SET @V_VRBASECALCREME = ROUND(@V_VRBASECALCIT, 2);
                              SET @V_VRIMPOSTOORIG = @V_VRIMPOSTOIT;
                              SET @V_VRBASECALCDEST = ROUND(@V_VRBASECALCREME, 2);
                              SET @V_VRIMPOSTODEST = @V_VRBASECALCDEST * (@V_ALIQICMSDEST / 100);
                              SET @V_DIFPARTILHAICMS = ROUND(@V_VRIMPOSTODEST - @V_VRIMPOSTOORIG, 2);
                              SET @V_IMPOQFECPDEST = ROUND(@V_VRBASECALCDEST * (@V_ALIQFECPDEST / 100), 2);
                              SET @V_VRIMPOPARTDEST = ROUND(@V_DIFPARTILHAICMS * (@V_VRPERCPARTILHA / 100), 2);
                              SET @V_VRIMPOPARTREME =  ROUND((@V_DIFPARTILHAICMS - @V_VRIMPOPARTDEST), 2);
                           END;
                        END;
                        UPDATE ITEMPROIMPOS
                           SET VRBASECALCDEST = CASE @V_CDFISCALIT WHEN '1' THEN @V_VRBASECALCDEST ELSE 0 END,
                               VRALIQINTEDEST = @V_ALIQICMSDEST,
                               VRPERCPARTILHA = @V_VRPERCPARTILHA,
                               VRIMPOPARTDEST = CASE @V_CDFISCALIT WHEN '1' THEN @V_VRIMPOPARTDEST ELSE 0 END,
                               VRIMPOPARTREME = CASE @V_CDFISCALIT WHEN '1' THEN @V_VRIMPOPARTREME ELSE 0 END,
                               VRALIQINTEREST = @V_VRALIQITEM,
                               VRALIQFCP = @V_ALIQFECPDEST,
                               VRIMPOFCP = @V_IMPOQFECPDEST,
                               VRBASECALCREME = CASE @V_CDFISCALIT WHEN '1' THEN @V_VRBASECALCREME ELSE 0 END
                         WHERE CDFILIAL = @P_CDFILIAL
                           AND NRLANCTONF = @P_NRLANCTONF
                           AND NRSEQITPROD = @C_ITEMPRODUTO_NRSEQITPROD
                           AND CDIMPOSTO = @V_CDIMPOSTO
                           AND NRITPROIMPOS = '1';
                     END;
                  END;
               END;
            END;
            FETCH NEXT FROM C_ITEMPRODUTO INTO @C_ITEMPRODUTO_NRSEQITPROD,
                                               @C_ITEMPRODUTO_CDARVPROD,
                                               @C_ITEMPRODUTO_VRTOTAITEM,
                                               @C_ITEMPRODUTO_VRDESCITEM,
                                               @C_ITEMPRODUTO_IDORIGEMPROD,
                                               @C_ITEMPRODUTO_CDFISCOPERSN;
         END;
         CLOSE C_ITEMPRODUTO;
         DEALLOCATE C_ITEMPRODUTO;
         --OBTENDO O MAIOR REGISTRO DA TABELA DE DADOS ADICIONAIS
         SELECT @V_NRDADOADIC = MAX(NRDADOADIC)
           FROM DADOSADIC
          WHERE CDFILIAL = @P_CDFILIAL
            AND NRLANCTONF = @P_NRLANCTONF;
         IF @V_NRDADOADIC IS NULL BEGIN
            SET @V_NRDADOADIC = '001';
         END ELSE BEGIN
            SET @V_NRDADOADIC = RIGHT(REPLICATE('0', 3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRDADOADIC) + 1)), 3);
         END;
         DECLARE C_VRIMPOPARTDEST CURSOR FOR SELECT VRALIQINTEDEST, 
                                                    VRALIQFCP,
                                                    SUM(VRIMPOPARTDEST) AS VRIMPOPARTDEST,
                                                    SUM(VRIMPOFCP) AS VRIMPOFCP
                                               FROM ITEMPROIMPOS IT, IMPOSTO I
                                              WHERE IT.CDIMPOSTO = I.CDIMPOSTO
                                                AND I.CDIMPOSTONFE = '00'
                                                AND CDFILIAL = @P_CDFILIAL
                                                AND NRLANCTONF = @P_NRLANCTONF
                                              GROUP BY VRALIQINTEDEST,
                                                    VRALIQFCP
                                             HAVING SUM(VRIMPOPARTDEST) > 0
                                              ORDER BY VRALIQINTEDEST
         OPEN C_VRIMPOPARTDEST;
         FETCH NEXT FROM C_VRIMPOPARTDEST INTO @C_VRIMPOPARTDEST_VRALIQINTEDEST,
                                               @C_VRIMPOPARTDEST_VRALIQFCP,
                                               @C_VRIMPOPARTDEST_VRIMPOPARTDEST,
                                               @C_VRIMPOPARTDEST_VRIMPOFCP;
         WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT @V_VRIMPOPARTDESTINO = CASE SUBSTRING(LTRIM(CONVERT(DECIMAL(13,2), @C_VRIMPOPARTDEST_VRIMPOPARTDEST)),1,1) WHEN '.' THEN '0' + LTRIM(CONVERT(DECIMAL(13,2), @C_VRIMPOPARTDEST_VRIMPOPARTDEST)) ELSE LTRIM(CONVERT(DECIMAL(13,2), @C_VRIMPOPARTDEST_VRIMPOPARTDEST)) END,
                   @V_VRALIQPARTDESTINO = CASE SUBSTRING(LTRIM(CONVERT(DECIMAL(3,2), @C_VRIMPOPARTDEST_VRIMPOPARTDEST)),1,1) WHEN '.' THEN '0' + LTRIM(CONVERT(DECIMAL(3,2), @C_VRIMPOPARTDEST_VRIMPOPARTDEST)) ELSE LTRIM(CONVERT(DECIMAL(3,2), @C_VRIMPOPARTDEST_VRIMPOPARTDEST)) END,
                   @V_VRIMPOFCPDESTINO = CASE SUBSTRING(LTRIM(CONVERT(DECIMAL(13,2), @C_VRIMPOPARTDEST_VRIMPOFCP)),1,1) WHEN '.' THEN '0' + LTRIM(CONVERT(DECIMAL(13,2), @C_VRIMPOPARTDEST_VRIMPOFCP)) ELSE LTRIM(CONVERT(DECIMAL(13,2), @C_VRIMPOPARTDEST_VRIMPOFCP)) END,
                   @V_VRALIQFCPDESTINO = CASE SUBSTRING(LTRIM(CONVERT(DECIMAL(3,2), @C_VRIMPOPARTDEST_VRALIQFCP)),1,1) WHEN '.' THEN '0' + LTRIM(CONVERT(DECIMAL(3,2), @C_VRIMPOPARTDEST_VRALIQFCP)) ELSE LTRIM(CONVERT(DECIMAL(3,2), @C_VRIMPOPARTDEST_VRALIQFCP)) END;
            IF @C_VRIMPOPARTDEST_VRIMPOFCP > 0 BEGIN
               SET @V_MSGDADOSADIC = 'Valor do ICMS interestadual para a UF de destino R$' + @V_VRIMPOPARTDESTINO + ' (Alquota interna do destinatrio ' + @V_VRALIQPARTDESTINO + '%, ' + @V_VRALIQFCPDESTINO + '% de FECP totalizando R$' + @V_VRIMPOFCPDESTINO + '), atendendo ao disposto na Emenda Constitucional n 87 de 2015';
            END ELSE BEGIN
               SET @V_MSGDADOSADIC = 'Valor do ICMS interestadual para a UF de destino R$' + @V_VRIMPOPARTDESTINO + ' (Alquota interna do destinatrio ' + @V_VRALIQPARTDESTINO + '%), atendendo ao disposto na Emenda Constitucional n 87 de 2015';
            END;
            INSERT INTO DADOSADIC
               (CDFILIAL, 
                NRLANCTONF, 
                NRDADOADIC, 
                CDMENSAGEM, 
                DSDADOADIC)
            VALUES
               (@P_CDFILIAL, 
                @P_NRLANCTONF, 
                @V_NRDADOADIC, 
                '', 
                @V_MSGDADOSADIC);
            SET @V_NRDADOADIC = RIGHT(REPLICATE('0', 3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRDADOADIC) + 1)), 3);
            FETCH NEXT FROM C_VRIMPOPARTDEST INTO @C_VRIMPOPARTDEST_VRALIQINTEDEST,
                                                  @C_VRIMPOPARTDEST_VRALIQFCP,
                                                  @C_VRIMPOPARTDEST_VRIMPOPARTDEST,
                                                  @C_VRIMPOPARTDEST_VRIMPOFCP;
         END;
         CLOSE C_VRIMPOPARTDEST;
         DEALLOCATE C_VRIMPOPARTDEST;
      END;
   END;
   DELETE
     FROM ALIQTEMP
    WHERE NRALIQTEMP = @V_ALIQTEMP;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_ICMS_INTERESTADUAL','6.10.xxx';
GO
